## qtubuntu-print 0.1+17.04.20170328

=== CMakeLists.txt ===
# Find packages
find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5PrintSupport REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(CONTENTHUB REQUIRED libcontent-hub)

# Replicate qmake CONFIG += plugin
add_definitions(${QT_DEFINITIONS})
add_definitions(-DQT_PLUGIN)
add_definitions(-DQT_NO_DEBUG)
add_definitions(-DQT_SHARED)

# Disable use of cups in Qt print support
add_definitions(-DQT_NO_CUPS)

# Setup include directories
include(GNUInstallDirs)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    ${Qt5PrintSupport_INCLUDE_DIRS}
    ${Qt5PrintSupport_PRIVATE_INCLUDE_DIRS}
    ${LIBCONTENT_HUB_INCLUDE_DIRS}
)

# Setup the library sources and name
set(LIBNAME qtubuntu-print)

set(
  qtubuntu_print_SRC
  constants.h
  i18n.cpp
  main.cpp
  qubuntuprintdevice.cpp
  qubuntuprintengine.cpp
  qubuntuprintsupport.cpp
)

add_library(${LIBNAME} SHARED ${qtubuntu_print_SRC})

qt5_use_modules(${LIBNAME} Core DBus PrintSupport Widgets)
target_link_libraries(${LIBNAME} content-hub)


# Install the plugin file
execute_process(
    COMMAND qmake -qt=qt5 -query QT_INSTALL_PLUGINS
            OUTPUT_VARIABLE QT_INSTALL_PLUGINS_DIR
            OUTPUT_STRIP_TRAILING_WHITESPACE
    )
install(TARGETS ${LIBNAME} DESTINATION ${QT_INSTALL_PLUGINS_DIR}/printsupport)


# Show files in QtC
file(GLOB QTC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     *.cpp *.h *.json)

add_custom_target(qtubuntu_print_qtc_files DEPENDS main.cpp SOURCES ${QTC_FILES})


# Set variables for outside use
set(SRC_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} PARENT_SCOPE)
set(SRC_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)
set(SRC_LIBNAME "lib${LIBNAME}" PARENT_SCOPE)

=== unittests/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
)

find_package(Qt5PrintSupport REQUIRED)
find_package(Qt5Test REQUIRED)

# Add the fakeprint plugin
add_subdirectory(fakeprint)

# Copy the library to a plugins folder
add_custom_target(unittest_copyFiles ALL
  COMMENT "Copying files: ${SRC_LIBNAME}.so and ${FAKEPRINT_LIBNAME}.so into separate PLUGIN/printsupport/lib.so folders"
  DEPENDS qtubuntu-print fakeprint)

add_custom_command(
  TARGET unittest_copyFiles
  COMMAND ${CMAKE_COMMAND} -E copy "${SRC_BINARY_DIR}/${SRC_LIBNAME}.so" "${CMAKE_CURRENT_BINARY_DIR}/qtubuntu-print/printsupport/${SRC_LIBNAME}.so"
  DEPENDS qtubuntu-print
  )
add_custom_command(
  TARGET unittest_copyFiles
  COMMAND ${CMAKE_COMMAND} -E copy "${FAKEPRINT_BINARY_DIR}/${FAKEPRINT_LIBNAME}.so" "${CMAKE_CURRENT_BINARY_DIR}/fakeprint/printsupport/${FAKEPRINT_LIBNAME}.so"
  DEPENDS fakeprint
  )

# Add the tests
add_executable(testFakePrinterInfo tst_fakeprinterinfo.cpp)
target_link_libraries(testFakePrinterInfo Qt5::Test Qt5::PrintSupport)
add_test(tst_fakeprinterInfo testFakePrinterInfo)

add_executable(testPrinterInfo tst_printerinfo.cpp)
target_link_libraries(testPrinterInfo Qt5::Test Qt5::PrintSupport)
add_test(tst_printerInfo testPrinterInfo)

=== unittests/fakeprint/CMakeLists.txt ===
# Find packages
find_package(Qt5Core REQUIRED)
find_package(Qt5PrintSupport REQUIRED)
find_package(PkgConfig REQUIRED)

# Replicate qmake CONFIG += plugin
add_definitions(${QT_DEFINITIONS})
add_definitions(-DQT_PLUGIN)
add_definitions(-DQT_NO_DEBUG)
add_definitions(-DQT_SHARED)

# Disable use of cups in Qt print support
add_definitions(-DQT_NO_CUPS)

# Setup include directories
include(GNUInstallDirs)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5PrintSupport_INCLUDE_DIRS}
    ${Qt5PrintSupport_PRIVATE_INCLUDE_DIRS}
    ${LIBCONTENT_HUB_INCLUDE_DIRS}
)

# Setup the library sources and name
set(LIBNAME fakeprint)
set(
  fakeprint_SRC
  main.cpp
)

add_library(${LIBNAME} SHARED ${fakeprint_SRC})
qt5_use_modules(${LIBNAME} Core PrintSupport)

# Show files in QtC
file(GLOB QTC_FILES
     RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
     *.cpp *.h *.json)

add_custom_target(fake_print_qtc_files DEPENDS main.cpp SOURCES ${QTC_FILES})


# Set variables for outside use
set(FAKEPRINT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} PARENT_SCOPE)
set(FAKEPRINT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)
set(FAKEPRINT_LIBNAME "lib${LIBNAME}" PARENT_SCOPE)

=== debian/changelog ===
qtubuntu-print (0.1+17.04.20170328-0ubuntu1) zesty; urgency=medium

  * Remove some depends as they are pulled in via shlibs:Depends (LP:
    #1673809)

 -- Andrew Hayzen <ahayzen@gmail.com>  Tue, 28 Mar 2017 13:37:26 +0000

qtubuntu-print (0.1+17.04.20170324-0ubuntu1) zesty; urgency=medium

  * Fix typo in copyright

 -- Andrew Hayzen <ahayzen@gmail.com>  Fri, 24 Mar 2017 11:00:44 +0000

qtubuntu-print (0.1+17.04.20170301.2-0ubuntu1) zesty; urgency=medium

  * Initial release
  * Initial commit
  * Move src files into their own directory
  * Add a readme

 -- Andrew Hayzen <ahayzen@gmail.com>  Wed, 01 Mar 2017 22:24:46 +0000

=== debian/control ===
Source: qtubuntu-print
Section: libs
Priority: optional
Maintainer: Andrew Hayzen <andrew.hayzen@canonical.com>
Build-Depends: cmake (>= 2.8.9),
               debhelper (>=9),
               dh-translations,
               libcontent-hub-dev,
               libqt5printsupport5,
               libqt5widgets5,
               pkg-config,
               qt5-qmake,
               qtbase5-dev,
               qtbase5-private-dev
Standards-Version: 3.9.7
Homepage: http://launchpad.net/qtubuntu-print
Vcs-Bzr: https://code.launchpad.net/~phablet-team/qtubuntu-print/trunk

Package: qtubuntu-print
Architecture: any
Depends: content-hub,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ubuntu-printing-app
Description: Print plugin for Qt sending PDFs over content-hub
 A printing plugin for Qt which creates a PDF and sends it
 over content-hub to a destination app.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@
